#include <windows.h>
#include <mmsystem.h>
#include "StdFile.h"
char szClassName[]="Game";
DWORD wX=0;
DWORD wY=0;
DWORD State=0;
void GameExit(HWND hWnd)
{
	DWORD wX=0;
	DWORD wY=0;
	BITMAP Bm;
	ShowCursor(TRUE);
	HDC hdc=GetDC(hWnd);
	HDC hMem=CreateCompatibleDC(hdc);
	HBITMAP Bitmap=LoadBitmap(GetModuleHandle(NULL),(char*)IDB_OVER);
	SelectObject(hMem,Bitmap);
	GetObject(Bitmap, sizeof(Bm),(LPSTR)&Bm);
	wX=((320-Bm.bmWidth)/2);
	wY=((320-Bm.bmHeight)/2);
	for(int i=0;i<wY;i++)
	{
		BitBlt(hdc,wX,i,Bm.bmWidth,Bm.bmHeight,hMem,0,0,SRCCOPY);
		PatBlt(hdc,wX,i,320,1,BLACKNESS);
		Sleep(3);
	}
	Sleep(2000);
	SendMessage(hWnd,WM_CREATE,0,0);
}
void ControlUp(HWND hWnd,DWORD Y)
{
	BITMAP Bm;
	HBITMAP Bitmap=0;
	HDC hdc=GetDC(hWnd);
	HDC hMem=CreateCompatibleDC(hdc);
	Bitmap=LoadBitmap(GetModuleHandle(NULL),(char*)IDB_ENEMY);
    SelectObject(hMem,Bitmap);
	GetObject(Bitmap, sizeof(Bm),(LPSTR)&Bm);
	BitBlt(hdc,wX,Y,Bm.bmWidth,Bm.bmHeight,hMem,0,0,SRCCOPY);
}
void ControlDown(HWND hWnd,DWORD Y)
{
	BITMAP Bm;
	HBITMAP Bitmap=0;
	HDC hdc=GetDC(hWnd);
	HDC hMem=CreateCompatibleDC(hdc);
	Bitmap=LoadBitmap(GetModuleHandle(NULL),(char*)IDB_ENEMY);
    SelectObject(hMem,Bitmap);
	GetObject(Bitmap, sizeof(Bm),(LPSTR)&Bm);
	BitBlt(hdc,wX,Y,Bm.bmWidth,Bm.bmHeight,hMem,0,0,SRCCOPY);
}
void ControlLeft(HWND hWnd,DWORD X)
{
	BITMAP Bm;
	HBITMAP Bitmap=0;
	HDC hdc=GetDC(hWnd);
	HDC hMem=CreateCompatibleDC(hdc);
	Bitmap=LoadBitmap(GetModuleHandle(NULL),(char*)IDB_ENEMY);
    SelectObject(hMem,Bitmap);
	GetObject(Bitmap, sizeof(Bm),(LPSTR)&Bm);
	BitBlt(hdc,X,wY,Bm.bmWidth,Bm.bmHeight,hMem,0,0,SRCCOPY);
}
void ControlRight(HWND hWnd,DWORD X)
{
	BITMAP Bm;
	HBITMAP Bitmap=0;
	HDC hdc=GetDC(hWnd);
	HDC hMem=CreateCompatibleDC(hdc);
	Bitmap=LoadBitmap(GetModuleHandle(NULL),(char*)IDB_ENEMY);
    SelectObject(hMem,Bitmap);
	GetObject(Bitmap, sizeof(Bm),(LPSTR)&Bm);
	BitBlt(hdc,X,wY,Bm.bmWidth,Bm.bmHeight,hMem,0,0,SRCCOPY);
}
LRESULT CALLBACK LowLevelKeyboardProc(int nCode, WPARAM wParam, LPARAM lParam) 
{
     PKBDLLHOOKSTRUCT p = (PKBDLLHOOKSTRUCT)lParam;
    HWND hWnd=GetActiveWindow();
    if (nCode == HC_ACTION) 
    {
		if(wParam==WM_KEYDOWN||wParam==WM_KEYUP)
		{
		    switch(p->vkCode)
		    {
			    case VK_RETURN:
				    ShowCursor(FALSE);
				    PatBlt(GetDC(hWnd),0,0,320,320,BLACKNESS);
				    GameExit(hWnd);
				    break;
			    case VK_DOWN:
				    State=2;
				    break;
			    case VK_LEFT:
				    State=4;
				    break;
			    case VK_RIGHT:
				    State=6;
				    break;
			    case VK_UP:
				    State=8;
				    break;
		    }
		}
		if(wParam==WM_KEYUP)
		{
		    switch(p->vkCode)
		    {
			    case VK_UP:
				    break;
			    case VK_DOWN:
				    break;
			    case VK_LEFT:
				    break;
			    case VK_RIGHT:
				    break;
		    }
		}
    }
    return  CallNextHookEx(NULL, nCode, wParam,lParam);
}
LRESULT CALLBACK WindowProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
    switch(uMsg)
    {
		case WM_CREATE:
			SetWindowTop(hWnd);
			PatBlt(GetDC(hWnd),0,0,320,320,BLACKNESS);
			AddString(hWnd,100,50,"ѵ99",20);
			AddString(hWnd,70,150,"Enterʼ",20);
			ExecuteMusic(IDS_BEGIN);
			break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
        case WM_PAINT:
            break;
		case WM_SYSCOMMAND:
			if(wParam==SC_MINIMIZE)
			{
			    MessageBox(hWnd,"С","Test",MB_OK);
			}
			if(wParam==SC_CLOSE)
			{
			    MessageBox(hWnd,"ر","Test",MB_OK);
			}
			if(wParam==SC_RESTORE)
			{
			    MessageBox(hWnd,"","Test",MB_OK);
			}
			break;
	}
    return DefWindowProc(hWnd,uMsg,wParam,lParam);
}
BOOL InitApplication(HINSTANCE hInst)
{
    WNDCLASS WndClass;
    WndClass.lpszClassName=szClassName;
    WndClass.lpszMenuName =NULL;
    WndClass.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
    WndClass.hCursor=LoadCursor(hInst,IDC_ARROW);
    WndClass.hIcon=LoadIcon(hInst,(char*)IDI_ICON);
    WndClass.hInstance=(HINSTANCE)hInst;
    WndClass.cbWndExtra=0;
    WndClass.cbClsExtra=0;
    WndClass.lpfnWndProc=WindowProc;
    WndClass.style=CS_HREDRAW|CS_VREDRAW;
    if(!RegisterClass(&WndClass))
        return FALSE;
    return TRUE;
}
HWND InitInstance(HINSTANCE hInst,int nShowCmd)
{
      HWND hWnd=CreateWindowEx(0,
        szClassName,
        "ѵ99",
        DS_MODALFRAME|DS_SYSMODAL|WS_CAPTION|WS_SYSMENU|WS_MINIMIZEBOX,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        320,
        320,
        NULL,
        NULL,
        hInst,
        0);
      ShowWindow(hWnd,nShowCmd);
      UpdateWindow(hWnd);
      return hWnd;
}
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd)
{
	HWND hWnd;
    MSG msg;
    InitApplication(hInstance);
	hWnd=InitInstance(hInstance,nShowCmd);
    HHOOK hhkLowLevelKybd  = SetWindowsHookEx(WH_KEYBOARD_LL, LowLevelKeyboardProc, hInstance, 0);

	while(WaitMessage())
	{
        if(PeekMessage(&msg,NULL,0,0,PM_REMOVE))
        { 
            if (msg.message == WM_QUIT) return msg.wParam;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
		switch(State)
		{
		    case 2:
				wY+=1;
				ControlDown(hWnd,wY);
			    break;
			case 4:
				wX-=1;
				ControlLeft(hWnd,wX);
				break;
			case 6:
				wX+=1;
				ControlLeft(hWnd,wX);
				break;
			case 8:
				wY-=1;
				ControlUp(hWnd,wY);
				break;
	    }
		State=0;
	}
    UnhookWindowsHookEx(hhkLowLevelKybd);
    return msg.wParam;
}
